unit Sg;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, StdCtrls, ExtCtrls, Menus, Buttons, Spin;

type
  TWerte = class
    Wert: LongInt;
    Min: LongInt;
    Max: LongInt;
  public
    constructor Create (a,b,c: LongInt); 
    procedure setval (a,b,c: LongInt);
    function add (a: LongInt): LongInt;
    function conv (a: LongInt; nk: Byte): String;
  end;

  TForm1 = class(TForm)
    AppPanel: TPanel;
    GLabel: TLabel;
    LabelZeit: TLabel;
    Labelwo: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    editzeit: TEdit;
    editwo: TEdit;
    editnorm: TEdit;
    editmin: TEdit;
    editmax: TEdit;
    Label9: TLabel;
    Zeitjetzt: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Timer1: TTimer;
    Label1: TLabel;
    Edit1: TEdit;
    zeitvorgabeedit: TEdit;
    radiojetzt: TRadioButton;
    radiofest: TRadioButton;
    kamel: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    DatumLabel: TLabel;
    SpinButton1: TSpinButton;
    SpinButton2: TSpinButton;
    SpinButton3: TSpinButton;
    SpinButton4: TSpinButton;
    SpinButton5: TSpinButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    Label2: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    PrintDialog1: TPrintDialog;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure editnormChange(Sender: TObject);
    procedure editzeitChange(Sender: TObject);
    procedure festClick(Sender: TObject);
    procedure jetztClick(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
     Procedure loadini (Profil: String);
     Procedure rechne;
     Function wert (s: string; nk: byte): longint;
     function zeit (s: string): longint;
     Procedure setproftext (prof: String; start: Boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses 
   inifiles, basis, profs;

Var 
   Startzeit: longint;
   aktzeit : longint;
   Startwo: longint;
   Temponorm: longint;
   Tempomin: longInt;
   Tempomax: longInt;
   zeitoffset: integer;
   vorgabezeit: longint;

   Zeitart: Boolean;
   zeitfest: String; 

   WertNorm: TWerte;
   wertmin: Twerte;
   wertmax: Twerte;
   minoffset: TWerte;
   startwert: TWerte;

   loading: Boolean;

constructor TWerte.Create (a,b,c: Longint); 
begin
   inherited create;
   setval(a,b,c);
end;

procedure TWerte.SetVal (a,b,c: LongInt);
begin
   wert := a;
   min := b;
   max := c;
end;

function TWerte.add (a: LongInt): LongInt;
Begin
   if a > 0 then
   begin
      if (a+wert) <= max then inc(wert,a)
      else wert := max
   end else
      if (wert+a) >= min then inc(wert,a)
      else wert := min;
   add := wert;
End;

function TWerte.conv (a: LongInt; nk: Byte): String;
var 
   s,st: string;
   v: longInt;
   n: integer;
   di: Longint;
begin
   s := '';
   di := 10;
   n := 0;
   if nk > 0 then
   begin
      while nk > 1 do
      begin
         di := di * 10;
         dec(nk);
      end;
      v := a DIV di;
      n := a MOD di;
   end else v := a;
   str(v,s);
   if n <> 0 then 
   begin
      str(n,st);
      s := s+','+st
   end;
   conv := s; 
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   Zeitjetzt.Caption := formatdatetime('h:mm',now);
   aktzeit := zeit(zeitjetzt.caption);
   datumlabel.caption := formatdatetime('dddd, d. mmmm yyyy', now);
   datumlabel.left := width-datumlabel.width-10;
   rechne;
end;

Procedure TForm1.loadini (profil: string);
var
   x: integer;
   w: longint;
   st: String;
   err: boolean;
begin
   loading := true;
   { dann zuerst ini }
   AppName := Paramstr(0);
   Appath := ExtractFilePath(AppName);
   Ininame := changefileext(extractfilename(AppName),'.INI');
   x := 0;
   try
      ini := TInifile.Create(IniName);
      { prfen, ob ini gefunden }
      st := ini.readstring(Profil,'Normal','');
      if st = '' then
      try
         ini.free;
         IniName := appath+IniName;
         ini := TInifile.Create(IniName);
         st := ini.readstring(Profil,'Normal','');
      except
      end;
      { welches profil? }
      {if Profil = '' then} 
      try
         lst := TStringList.Create;
         ini.readsection('Profile',lst);
         if lst.count = 0 then lst.add(default);
         x := lst.count;
      except
      end;
   finally
      ini.free;
   end;

   try
      if (profil = '') and (x > 1) then
      begin
         {auswahl}
         x := form2.showmodal;
         if x = mrCancel then
         begin
            ini := TIniFile.Create(IniName);
            loading := false;
            lst.free;
            exit;
         end;
         profil := prof;
      end
      else if profil = '' then profil := lst.strings[0];

         ini := TIniFile.Create(IniName);
   
      try
         lst.free;
      except
      end;

      if not loading then exit;
      if profil = '' then profil := default;
      {
       werte vorgeben }
      st := ini.readstring(Profil,'Normal','');
      if st = '' then st := '5';

      try
         { strmung }
         w := wert(st,1);
         temponorm := w;
         wertnorm.wert := w;
         editnorm.text := st;
         st := ini.readstring(Profil,'Min','2');
         w := wert(st,1);
         tempomin := w;
         wertmin.wert := w;
         editmin.text := st;
         st := ini.readstring(Profil,'Max','6');
         w := wert(st,1);
         tempomax := w;
         wertmax.wert := w;
         editmax.text := st;
         { start }
         st := ini.readstring(Profil,'Von wo','716,5');
         w := wert(st,1);
         startwo := w;
         startwert.wert := w;
         editwo.text := st;
         { offset }
         st := ini.readstring(Profil,'Offset','0');
         w := wert(st,0);
         zeitoffset := w;
         minoffset.wert := w;
         edit1.text := st;
         if profil <> default then
         begin
            st := ini.readstring(Profil,'Vorgabezeit',Zeitfest);
            w := zeit(st);
            vorgabezeit := w;
            zeitvorgabeedit.text := st;
            radiojetzt.checked := ini.readbool(
              Profil,'Jetzt',true);
            radiofest.checked := ini.readbool(
              Profil,'Fest',false);
            st := ini.readstring(Profil,'Von Zeit',Zeitfest);
            w := zeit(st);
            startzeit := w;
            EditZeit.text := st;
            profdatum := ini.readstring(profil,'Datum',
                           formatdatetime('dddd, d. mmmm yyyy',now));
            profzeit := ini.readstring(profil,'Zeit',
                           formatdatetime('h:mm',now));
         end;
      except
      end;
   finally
      try
         ini.free;
      except
      end;
   end;
   loading := false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   { wertvorgaben }
   wertnorm := TWerte.Create(60,0,200);
   wertmin := TWerte.Create(30,0,200);
   wertmax := TWerte.Create(70,0,200);
   minoffset := TWerte.Create(0,0,200);
   startwert := TWerte.Create(7164,0,10000);
   StartZeit := 0;
   loadini(Default);
   profdatum := '';
   profzeit := '';
   { weitere vorgaben }
   radiofest.checked := false;
   radiojetzt.checked := true;
   Zeitfest := formatdatetime('h:mm',now);
   zeitvorgabeedit.text := zeitfest;
   zeitvorgabeedit.enabled := false;
   zeitvorgabeedit.refresh;
   Zeitart := radiojetzt.checked;
   editnormchange(editnorm);
   editnormchange(editmax);
   editnormchange(editmin);
   editnormchange(editwo);
   editnormchange(edit1);
   timer1timer(self);
   editzeit.text := zeitjetzt.caption;
   startzeit := zeit(editzeit.text);
   aktzeit := zeit(zeitjetzt.caption);
   setproftext(default,true);
end;

Procedure tform1.setproftext (prof: String; start: Boolean);
var
   i: integer;
begin
   if start then
      label2.caption := 'aktuelles Profil'
   else if prof = default then
      label2.caption := 'Profil "'+prof+'" (Standard)'
   else
      label2.caption := 'Profil "'+prof+'" vom '
                        +profdatum+' / '+profzeit;
   label2.left := (width-label2.width) DIV 2;
end;

function tform1.wert (s: string; nk: byte): Longint;
var 
   w: longint; 
   i: longint; f: integer;
   p: byte;
   st, stw: string;
begin
   wert := -1;
   w := 0;
   st := s;
   p := 1;
   { trim }
   while (p <= length(st)) and (st[p] = ' ') do
      st := copy(st,2,length(st)-1);
   while (length(st) > 0) and (st[length(st)] = ' ') do
      dec(st[0]);
   { vorkomma }
   wert := 0;
   stw := '';
   while (p <= length(st)) and (st[p] >= '0') And (st[p] <= '9') do
   begin
      stw := stw + st[p];
      st := copy(st,2,length(st)-1);
      inc(i);
   end;
   if length(st) > 0 then
   begin
      if (st[1] <> ',') or (nk = 0) then 
      begin
         wert := -1;
         exit;
      end else
        st := copy(st,2,length(st)-1);
   end;
   { nachkomma };
   i := 0;
   while (p <= length(st)) and (i < nk) and (st[p] >= '0') And (st[p] <= '9') do
   begin
      stw := stw + st[p];
      st := copy(st,2,length(st)-1);
      inc(i);
   end;
   while i < nk do
   begin
      stw := stw + '0';
      inc(i);
   end;
   val(stw,w,f);
   wert := w;
end;

procedure tform1.rechne;
var diff,ab: longint;
    hh,mm: longint;
    st: string;
    abv, abn: integer;
    ziel: longint;
begin
   {vergangene zeit}
   if zeitart then
     diff := aktzeit-startzeit+zeitoffset
   else diff := vorgabezeit-startzeit+zeitoffset;
   hh := diff DIV 60;
   mm := diff mod 60;
   str(hh:1,st);
   label12.caption := st+':';
   str(mm:2,st);
   if st[1] = ' ' then st[1] := '0';
   label12.caption := label12.caption+st;
   {abgetrieben + ziel}
   { norm }
   ab := (temponorm*diff) DIV 60;
   abv := ab DIV 10;
   abn := ab MOD 10;
   str(abv:1,st);
   label10.caption := st+',';
   str(abn:1,st);
   if st[1] = ' ' then st[1] := '0';
   label10.caption := label10.caption+st;
   ziel := ab + startwo;
   abv := ziel DIV 10;
   abn := ziel MOD 10;
   str(abv:1,st);
   label11.caption := st+',';
   str(abn:1,st);
   if st[1] = ' ' then st[1] := '0';
   label11.caption := label11.caption+st;
   { min }
   ab := (tempomin*diff) DIV 60;
   abv := ab DIV 10;
   abn := ab MOD 10;
   str(abv:1,st);
   label19.caption := st+',';
   str(abn:1,st);
   if st[1] = ' ' then st[1] := '0';
   label19.caption := label19.caption+st;
   ziel := ab + startwo;
   abv := ziel DIV 10;
   abn := ziel MOD 10;
   str(abv:1,st);
   label20.caption := st+',';
   str(abn:1,st);
   if st[1] = ' ' then st[1] := '0';
   label20.caption := label20.caption+st;
   { max }
   ab := (tempomax*diff) DIV 60;
   abv := ab DIV 10;
   abn := ab MOD 10;
   str(abv:1,st);
   label22.caption := st+',';
   str(abn:1,st);
   if st[1] = ' ' then st[1] := '0';
   label22.caption := label22.caption+st;
   ziel := ab + startwo;
   abv := ziel DIV 10;
   abn := ziel MOD 10;
   str(abv:1,st);
   label23.caption := st+',';
   str(abn:1,st);
   if st[1] = ' ' then st[1] := '0';
   label23.caption := label23.caption+st;
end;

function tform1.zeit (s: string): longint;
var 
   st, stw: string;
   p, i: integer;
   hh,mm: longint; 
begin
   st := s;
   p := 1;
   { trim }
   while (p <= length(st)) and (st[p] = ' ') do
      st := copy(st,2,length(st)-1);
   while (length(st) > 0) and (st[length(st)] = ' ') do
      dec(st[0]);
   { stunden }
   stw := '';
   while (p <= length(st)) and (st[p] >= '0') And (st[p] <= '9') do
   begin
      stw := stw + st[p];
      st := copy(st,2,length(st)-1);
   end;
   if length(stw) = 0 then stw := '0'+stw;
   if length(stw) = 1 then stw := '0'+stw;
   val(stw,hh,i);
   if (hh > 23) then
   begin
      zeit := -1;
      exit;
   end;
   if length(st) > 0 then
   begin
      if st[1] <> ':' then 
      begin
         zeit := -1;
         exit;
      end else
        st := copy(st,2,length(st)-1);
   end;
   { minuten };
   stw := '';
   while (p <= length(st)) and (st[p] >= '0') And (st[p] <= '9') do
   begin
      stw := stw + st[p];
      st := copy(st,2,length(st)-1);
      inc(i);
   end;
   if length(stw) = 0 then stw := stw+'0';
   if length(stw) = 1 then stw := stw+'0';
   val(stw,mm,i);
   if mm > 59 then
   begin
      zeit := -1;
      exit;
   end;
   zeit := hh*60+mm;
end;

procedure TForm1.editnormChange(Sender: TObject);
var w: longint;
    s: string;
    lg: byte;
begin
   lg := 1;
   if tedit(sender).tag = 5 then lg := 0;
   w := wert(tedit(sender).text,lg);
   if w < 0 then
      showmessage('falscher Wert')
   else
   begin
      case tedit(sender).tag of
         1: startwo := w;
         2: begin
               temponorm := w;
               wertnorm.wert := w;
            end;
         3: begin
               tempomin := w;
               wertmin.wert := w;
            end;
         4: begin 
               tempomax := w;
               wertmax.wert := w;
            end;
         5: zeitoffset := w;
      end;
      rechne;
   end;
end;

procedure TForm1.editzeitChange(Sender: TObject);
var w: longint;
begin
   w := zeit(tedit(sender).text);
   if w < 0 then
      showmessage('falsche Zeit')
   else
   begin
      case tedit(sender).tag of
         0: startzeit := w;
         2: vorgabezeit := w;
      end;
      rechne;
   end;
end;

procedure TForm1.festClick(Sender: TObject);
begin
   zeitart := radiojetzt.checked;
   zeitvorgabeedit.enabled := true;
   try
      if radiofest.checked then
         zeitvorgabeedit.setfocus;
   except
   end;
   timer1timer(self);
end;

procedure TForm1.jetztClick(Sender: TObject);
begin
   zeitart := true;
 {  zeitvorgabeedit.hide; }
   zeitvorgabeedit.enabled := false;
   try
      editzeit.setfocus;
   except
   end;
   timer1timer(self);
end;

procedure TForm1.Label1Click(Sender: TObject);
begin
   Tlabel(sender).FocusControl.setfocus;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
   close;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
{   if messagedlg('Bildschirm ausdrucken?',mtConfirmation,
      mbOkCancel,0) = mrOk then print; }
   if printdialog1.execute then
      print;  
end;

procedure TForm1.SpinButton1DownClick(Sender: TObject);
var s: string;
begin
   With (sender As TSpinButton) do
   begin
      Case Tag Of
         1: s := wertnorm.conv(wertnorm.add(-5),1);
         2: s := wertmin.conv(wertmin.add(-5),1);
         3: s := wertmax.conv(wertmax.add(-5),1);
         4: s := startwert.conv(startwert.add(-1),1);
         5: s := minoffset.conv(minoffset.add(-1),0);
      end;
      ((sender as Tspinbutton).focusControl As TEdit).Text 
        := S;
   end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   wertnorm.free;
   wertmin.free;
   wertmax.free;
   minoffset.free;
   startwert.free;
end;

procedure TForm1.SpinButton1UpClick(Sender: TObject);
var s: string;
begin
   With (sender As TSpinButton) do
   begin
      Case Tag Of
         1: s := wertnorm.conv(wertnorm.add(5),1);
         2: s := wertmin.conv(wertmin.add(5),1);
         3: s := wertmax.conv(wertmax.add(5),1);
         4: s := startwert.conv(startwert.add(1),1);
         5: s := minoffset.conv(minoffset.add(1),0);
      end;
      ((sender as Tspinbutton).focusControl As TEdit).Text 
        := S;
   end;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var i: integer;
begin
   try
      ini := TInifile.Create(IniName);
      lst := TStringList.Create;
      ini.readsection('Profile',lst);
      if lst.count = 0 then
         lst.add(default);
   finally
      ini.free;
   end;
   loadstore := speichern;
   prof := '';
   if form2.showmodal = mrcancel then 
   begin
      lst.free;
      exit;
   end;
   if prof = '' then prof := default;
   try
      ini := TInifile.Create(IniName);
      ini.erasesection('Profile');
      for i := 0 to lst.count-1 do
         ini.writestring('Profile',lst.strings[i],'1');
      ini.writestring(prof,'Normal',editnorm.text);
      ini.writestring(prof,'Min',editmin.text);
      ini.writestring(prof,'Max',editmax.text);
      ini.writestring(prof,'Von wo',editwo.text);
      ini.writestring(prof,'Offset',edit1.text);
      if (prof <> default) and radiojetzt.checked then
         ini.writestring(prof,'Vorgabezeit',
           zeitjetzt.caption)
      else
         ini.writestring(prof,'Vorgabezeit',
           zeitvorgabeedit.text);
      ini.writestring(prof,'Von Zeit',editzeit.text);
      ini.writebool(prof,'Jetzt',false);
      ini.writebool(prof,'Fest',true);
      ini.writestring(prof,'Datum',
            formatdatetime('dddd, d. mmmm yyyy',now));
      ini.writestring(prof,'Zeit',
            formatdatetime('h:mm',now));
   finally
      try
         lst.free;
         ini.free;
      except
      end;
   end;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
   if loading then exit;
   loadstore := laden;
   loadini('');   
   if prof <> '' then setproftext(prof,false);
   editnormchange(editnorm);
   editnormchange(editmax);
   editnormchange(editmin);
   editnormchange(editwo);
   editnormchange(edit1);
   timer1timer(self);
   {editzeit.text := zeitjetzt.caption;}
   {startzeit := zeit(editzeit.text);}
   aktzeit := zeit(zeitjetzt.caption);
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
var i: integer;
begin
   try
      lst := TStringList.Create;
      try
         ini := TInifile.Create(IniName);
         ini.readsection('Profile',lst);
         if lst.count = 0 then
            lst.add(default);
      finally
         ini.free;
      end;
      loadstore := bearbeiten;
      prof := '';
      form2.showmodal;
   finally
      lst.free
   end;
end;

end.
 